/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.1801 from the
 * contents of libmemcached.xs. Do not edit this file, edit libmemcached.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "libmemcached.xs"
/*
 * vim: expandtab:sw=4
 * */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <libmemcached/memcached.h>

#define MEMCACHED_CALLBACK_MALLOC_FUNCTION 4
#define MEMCACHED_CALLBACK_REALLOC_FUNCTION 5
#define MEMCACHED_CALLBACK_FREE_FUNCTION 6

/* See also the typemap as most of the interesting glue is there */

/* mapping C types to perl classes - keep typemap file in sync */
typedef memcached_st*        Memcached__libmemcached;
typedef uint32_t             lmc_data_flags_t;
typedef char*                lmc_key;
typedef char*                lmc_value;
typedef time_t               lmc_expiration;

/* pointer chasing:
 *
 * $memc is a scalar (SV) containing a reference (RV) to a hash (HV) with magic (mg):
 *
 * RV -> HV -> mg -> lmc_state -> memcached_st (-> MEMCACHED_CALLBACK_USER_DATA points back to lmc_state)
 *
 */

/* get a memcached_st structure from a $memc */
#define LMC_STATE_FROM_SV(sv) \
    (mg_find(SvRV(sv), '~')->mg_obj)

#define LMC_PTR_FROM_SV(sv) \
    ((lmc_state_st*)LMC_STATE_FROM_SV(sv))->ptr

/* get our lmc_state structure from a memcached_st ptr */
#define LMC_STATE_FROM_PTR(ptr) \
    ((lmc_state_st*)memcached_callback_get(ptr, MEMCACHED_CALLBACK_USER_DATA, NULL))

/* get trace level from memcached_st ptr */
#define LMC_TRACE_LEVEL_FROM_PTR(ptr) \
    ((ptr) ? LMC_STATE_FROM_PTR(ptr)->trace_level : 0)

/* check memcached_return value counts as success */
#define LMC_RETURN_OK(ret) \
    (ret==MEMCACHED_SUCCESS || ret==MEMCACHED_STORED || ret==MEMCACHED_DELETED || ret==MEMCACHED_END || ret==MEMCACHED_BUFFERED)

/* store memcached_return value in our lmc_state structure */
#define LMC_RECORD_RETURN_ERR(what, ptr, ret) \
    STMT_START {    \
        lmc_state_st* lmc_state = LMC_STATE_FROM_PTR(ptr); \
        if (lmc_state) { \
            if (lmc_state->trace_level > 1 || (lmc_state->trace_level && !LMC_RETURN_OK(ret))) \
                warn("\t<= %s return %d %s", what, ret, memcached_strerror(ptr, ret)); \
            lmc_state->last_return = ret;   \
            lmc_state->last_errno  = memcached_last_error_errno(ptr); /* if MEMCACHED_ERRNO */ \
        } else { /* should never happen */ \
            warn("LMC_RECORD_RETURN_ERR(%d %s): no lmc_state structure in memcached_st so error not recorded!", \
                ret, memcached_strerror(ptr, ret)); \
        } \
    } STMT_END


/* ====================================================================================== */


typedef struct lmc_state_st lmc_state_st;
typedef struct lmc_cb_context_st lmc_cb_context_st;

/* context information for callbacks */
struct lmc_cb_context_st {
    lmc_state_st *lmc_state;
    SV *dest_sv;
    HV *dest_hv;
    memcached_return *rc_ptr;
    lmc_data_flags_t *flags_ptr;
    UV  result_count;
    SV  *get_cb;
    SV  *set_cb;
    /* current set of keys for mget */
    char   **key_strings;
    size_t  *key_lengths;
    IV       key_alloc_count;
};

/* perl api state information associated with an individual memcached_st */
struct lmc_state_st {
    memcached_st    *ptr;
    HV              *hv;    /* pointer back to HV (not refcntd) */
    IV               trace_level;
    int              options;
    memcached_return last_return;
    int              last_errno;
    /* handy default fetch context for fetching single items */
    lmc_cb_context_st *cb_context; /* points to _cb_context by default */
    lmc_cb_context_st _cb_context;
};

static lmc_state_st *
lmc_state_new(memcached_st *ptr, HV *memc_hv)
{
    char *trace = getenv("PERL_LIBMEMCACHED_TRACE");
    lmc_state_st *lmc_state;
    Newz(0, lmc_state, 1, struct lmc_state_st);
    lmc_state->ptr = ptr;
    lmc_state->hv  = memc_hv;
    lmc_state->cb_context = &lmc_state->_cb_context;
    lmc_state->cb_context->lmc_state = lmc_state;
    lmc_state->cb_context->set_cb = newSV(0);
    lmc_state->cb_context->get_cb = newSV(0);
    if (trace) {
        lmc_state->trace_level = (IV)atoi(trace);
    }
    return lmc_state;
}


/* ====================================================================================== */


static void
_prep_keys_buffer(lmc_cb_context_st *lmc_cb_context, int keys_needed)
{
    IV trace_level = lmc_cb_context->lmc_state->trace_level;
    if (keys_needed <= lmc_cb_context->key_alloc_count) {
        if (trace_level >= 9)
            warn("reusing keys buffer");
        return;
    }
    if (!lmc_cb_context->key_strings) {
        Newx(lmc_cb_context->key_strings, keys_needed, char *);
        Newx(lmc_cb_context->key_lengths, keys_needed, size_t);
        if (trace_level >= 3)
            warn("new keys buffer");
    }
    else {
        keys_needed *= 1.2;
        Renew(lmc_cb_context->key_strings, keys_needed, char *);
        Renew(lmc_cb_context->key_lengths, keys_needed, size_t);
        if (trace_level >= 3)
            warn("growing keys buffer %d->%d", (int)lmc_cb_context->key_alloc_count, keys_needed);
    }
    lmc_cb_context->key_alloc_count = keys_needed;
}


static memcached_return
_prep_keys_lengths(memcached_st *ptr, SV *keys_rv, char ***out_keys, size_t **out_key_length, unsigned int *out_number_of_keys)
{
    SV *keys_sv;
    unsigned int number_of_keys;
    char **keys;
    size_t *key_length;
    int i = 0;

    lmc_state_st *lmc_state = LMC_STATE_FROM_PTR(ptr);
    lmc_cb_context_st *lmc_cb_context = lmc_state->cb_context;

    if (!SvROK(keys_rv))
        return MEMCACHED_NO_KEY_PROVIDED;
    keys_sv = SvRV(keys_rv);
    if (SvRMAGICAL(keys_rv)) /* disallow tied arrays for now */
        return MEMCACHED_NO_KEY_PROVIDED;

    if (SvTYPE(keys_sv) == SVt_PVAV) {
        number_of_keys = AvFILL(keys_sv)+1;
        if (number_of_keys > lmc_cb_context->key_alloc_count)
            _prep_keys_buffer(lmc_cb_context, number_of_keys);
        keys       = lmc_cb_context->key_strings;
        key_length = lmc_cb_context->key_lengths;
        for (i = 0; i < number_of_keys; i++) {
            keys[i] = SvPV(AvARRAY(keys_sv)[i], key_length[i]);
        }
    }
    else if (SvTYPE(keys_sv) == SVt_PVHV) {
        HE *he;
        I32 retlen;
        hv_iterinit((HV*)keys_sv);
        number_of_keys = HvKEYS(keys_sv);
        if (number_of_keys > lmc_cb_context->key_alloc_count)
            _prep_keys_buffer(lmc_cb_context, number_of_keys);
        keys       = lmc_cb_context->key_strings;
        key_length = lmc_cb_context->key_lengths;
        while ( (he = hv_iternext((HV*)keys_sv)) ) {
            keys[i] = hv_iterkey(he, &retlen);
            key_length[i++] = retlen;
        }
    }
    else {
        return MEMCACHED_NO_KEY_PROVIDED;
    }
    *out_number_of_keys = number_of_keys;
    *out_keys           = keys;
    *out_key_length     = key_length;
    return MEMCACHED_SUCCESS;
}


/* ====================================================================================== */

/* --- callbacks for memcached_fetch_execute ---
 */

static unsigned int
_cb_prep_store_into_sv_of_hv(memcached_st *ptr, memcached_result_st *result, void *context)
{
    /* Set dest_sv to the appropriate sv in dest_hv              */
    /* Called before _cb_store_into_sv when fetching into a hash */
    lmc_cb_context_st *lmc_cb_context = context;
    SV **svp = hv_fetch( lmc_cb_context->dest_hv, memcached_result_key_value(result), memcached_result_key_length(result), 1);
    lmc_cb_context->dest_sv = *svp;
    return 0;
}

static unsigned int
_cb_store_into_sv(memcached_st *ptr, memcached_result_st *result, void *context)
{
    /* Store result value and flags into places specified by lmc_cb_context */
    /* This is the 'core' fetch callback. Increments result_count.             */
    lmc_cb_context_st *lmc_cb_context = context;
    ++lmc_cb_context->result_count;
    *lmc_cb_context->flags_ptr = memcached_result_flags(result);
    sv_setpvn(lmc_cb_context->dest_sv, memcached_result_value(result), memcached_result_length(result));
    if (lmc_cb_context->lmc_state->trace_level >= 2)
        warn("fetched %s (value len %d, flags %lu)\n",
            memcached_result_key_value(result), (int) memcached_result_length(result), (long unsigned int)memcached_result_flags(result));
    return 0;
}


/* XXX - Notes:
 * Perl callbacks are called as
 *
 *    sub {
 *      my ($key, $flags) = @_;  # with $_ containing the value
 *    }
 *
 * Modifications to $_ (value) and $_[1] (flags) propagate to other callbacks,
 * and thus to libmemcached.
 * Callbacks can't recurse within the same $memc at the moment.
 */
static unsigned int
_cb_fire_perl_cb(lmc_cb_context_st *lmc_cb_context, SV *callback_sv, SV *key_sv, SV *value_sv, SV *flags_sv, SV *cas_sv)
{
    int items;
    dSP;

    ENTER;
    SAVETMPS;

    SAVE_DEFSV; /* local($_) = $value */
    DEFSV = value_sv;

    PUSHMARK(SP);
    EXTEND(SP, 2);
    PUSHs(key_sv);
    PUSHs(flags_sv);
    if (cas_sv)
        PUSHs(cas_sv);
    PUTBACK;

    items = call_sv(callback_sv, G_ARRAY);
    SPAGAIN;

    if (items) /* may use returned items for signalling later */
        croak("callback returned non-empty list");

    FREETMPS;
    LEAVE;
    return 0;
}


static unsigned int
_cb_fire_perl_set_cb(memcached_st *ptr, SV *key_sv, SV *value_sv, SV *flags_sv)
{
    /* XXX note different api to _cb_fire_perl_get_cb */
    lmc_state_st *lmc_state = LMC_STATE_FROM_PTR(ptr);
    lmc_cb_context_st *lmc_cb_context = lmc_state->cb_context;
    unsigned int status;

    if (!SvOK(lmc_cb_context->set_cb))
        return 0;

    status = _cb_fire_perl_cb(lmc_cb_context, lmc_cb_context->set_cb, key_sv, value_sv, flags_sv, NULL);
    return status;
}

static unsigned int
_cb_fire_perl_get_cb(memcached_st *ptr, memcached_result_st *result, void *context)
{
    /* designed to be called via memcached_fetch_execute() */
    lmc_cb_context_st *lmc_cb_context = context;
    SV *key_sv, *value_sv, *flags_sv, *cas_sv;
    unsigned int status;

    if (!SvOK(lmc_cb_context->get_cb))
        return 0;

    /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
    /* which would save the create,mortalize,destroy costs for each invocation  */
    key_sv   = sv_2mortal(newSVpv(memcached_result_key_value(result), memcached_result_key_length(result)));
    value_sv = lmc_cb_context->dest_sv;
    flags_sv = sv_2mortal(newSVuv(*lmc_cb_context->flags_ptr));
    if (memcached_behavior_get(ptr, MEMCACHED_BEHAVIOR_SUPPORT_CAS)) {
        uint64_t cas = memcached_result_cas(result);
        warn("cas not fully supported"); /* if sizeof UV < sizeof uint64_t */
        cas_sv = sv_2mortal(newSVuv(cas));
    }
    else cas_sv = NULL;

    SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */

    status = _cb_fire_perl_cb(lmc_cb_context, lmc_cb_context->get_cb, key_sv, value_sv, flags_sv, cas_sv);
    /* recover potentially modified values */
    *lmc_cb_context->flags_ptr = SvUV(flags_sv);

    return status;
}

typedef unsigned int (*memcached_callback_fp)(memcached_st *ptr, memcached_result_st *result, void *context);

memcached_callback_fp lmc_store_hv_get[3][3] = {
    { _cb_prep_store_into_sv_of_hv, _cb_store_into_sv,                       },
    { _cb_prep_store_into_sv_of_hv, _cb_store_into_sv, _cb_fire_perl_get_cb, },
};
memcached_callback_fp lmc_store_sv_get[3][3] = {
    {                               _cb_store_into_sv,                       },
    {                               _cb_store_into_sv, _cb_fire_perl_get_cb, },
};


/* ====================================================================================== */


static SV *
_fetch_one_sv(memcached_st *ptr, lmc_data_flags_t *flags_ptr, memcached_return *error_ptr)
{
    lmc_cb_context_st *lmc_cb_context = LMC_STATE_FROM_PTR(ptr)->cb_context;

    int callback_ix = 0;
    memcached_callback_fp callbacks[5];
    callbacks[callback_ix++] = _cb_store_into_sv;
    if (SvOK(lmc_cb_context->get_cb))
        callbacks[callback_ix++] = _cb_fire_perl_get_cb;
    callbacks[callback_ix  ] = NULL;

    if (*error_ptr != MEMCACHED_SUCCESS)    /* did preceeding mget succeed */
        return &PL_sv_undef;

    lmc_cb_context->dest_sv   = newSV(0);
    lmc_cb_context->flags_ptr = flags_ptr;
    lmc_cb_context->rc_ptr    = error_ptr;
    lmc_cb_context->result_count = 0;

    *error_ptr = memcached_fetch_execute(ptr, (memcached_execute_fn *)callbacks, lmc_cb_context, callback_ix);

    if (lmc_cb_context->result_count == 0 && (*error_ptr == MEMCACHED_SUCCESS || *error_ptr == MEMCACHED_END))
        *error_ptr = MEMCACHED_NOTFOUND; /* to match memcached_get behaviour */
    else if (lmc_cb_context->result_count > 0 && *error_ptr == MEMCACHED_END)
        *error_ptr = MEMCACHED_SUCCESS; /* to match memcached_get behaviour */

    return lmc_cb_context->dest_sv;
}


static memcached_return
_fetch_all_into_hashref(memcached_st *ptr, memcached_return rc, HV *dest_ref)
{
    lmc_cb_context_st *lmc_cb_context = LMC_STATE_FROM_PTR(ptr)->cb_context;
    lmc_data_flags_t flags;

    int callback_ix = 0;
    memcached_callback_fp callbacks[5];
    callbacks[callback_ix++] = _cb_prep_store_into_sv_of_hv;
    callbacks[callback_ix++] = _cb_store_into_sv;
    if (SvOK(lmc_cb_context->get_cb))
        callbacks[callback_ix++] = _cb_fire_perl_get_cb;
    callbacks[callback_ix  ] = NULL;

    lmc_cb_context->dest_hv   = dest_ref;
    lmc_cb_context->flags_ptr = &flags;  /* local, not safe for caller */
    lmc_cb_context->rc_ptr    = &rc;     /* local, not safe for caller */
    lmc_cb_context->result_count = 0;

    /* rc is the return code from the preceeding mget */
    if (!LMC_RETURN_OK(rc)) {
        if (rc == MEMCACHED_INVALID_ARGUMENTS) {
            /* when number_of_keys==0 memcached_mget returns MEMCACHED_INVALID_ARGUMENTS
            * which we'd normally translate into a false return value
            * but that's not really appropriate here
            */
            return MEMCACHED_SUCCESS;
        }
        return rc;
    }

    rc = memcached_fetch_execute(ptr, (memcached_execute_fn *)callbacks, (void *)lmc_cb_context, callback_ix);
    if (rc == MEMCACHED_NOTFOUND || rc == MEMCACHED_SUCCESS) {
        return MEMCACHED_SUCCESS; /* This is a success, no matter what */
    }
    return rc;
}


static memcached_return_t
_walk_stats_cb(const memcached_instance_st *instance,
    const char *key,   size_t key_length,
    const char *value, size_t value_length,
    void *cb)
{
    dSP;
    int items;

    /* callback is called with key, value, hostname, typename */
    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSVpv(key, key_length)));
    XPUSHs(sv_2mortal(newSVpv(value, value_length)));
    XPUSHs(sv_2mortal(newSVpvf("%s:%d",
        memcached_server_name(instance), memcached_server_port(instance))));
    XPUSHs(DEFSV); /* XXX deprecated $stats_arg in $_ */
    PUTBACK;
    items = call_sv((SV*)cb, G_ARRAY);
    SPAGAIN;
    if (items) /* XXX may use returned items for signalling later */
        croak("walk_stats callback returned non-empty list");

    return MEMCACHED_SUCCESS;
}



#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 451 "libmemcached.c"

/* INCLUDE:  Including 'const-xs.inc' from 'libmemcached.xs' */


XS(XS_Memcached__libmemcached_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_constant)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	IV	RETVAL;
	dXSTARG;
#line 149 "const-xs.inc"
	RETVAL = ix;
#line 473 "libmemcached.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'libmemcached.xs' from 'const-xs.inc' */


XS(XS_Memcached__libmemcached_memcached_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "ptr=NULL");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 453 "libmemcached.xs"
        SV *class_sv = (items >= 1) ? ST(0) : NULL;
#line 498 "libmemcached.c"
	Memcached__libmemcached	RETVAL;
	Memcached__libmemcached	ptr;

	if (items < 1)
	    ptr = NULL;
	else {
	/* T_MEMCACHED */
	if (!SvOK(ST(0))) {  /* undef	 */
	    ptr = NULL;    /* treat as null */
	}
	else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
	    if (SvROK(ST(0))) {
		ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
	    }
	    else { /* memcached_st ptr already freed or is a class name */
		ptr = NULL;
	    }
	}
	else
	    croak("ptr is not of type Memcached::libmemcached");
	if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
	    warn("	=> %s(%s %s = 0x%p)", "memcached_create", "Memcached__libmemcached", "ptr", (void*)ptr);
	}
#line 455 "libmemcached.xs"
        ptr = NULL; /* force null even if arg provided */
        PERL_UNUSED_VAR(ix);
#line 525 "libmemcached.c"

	RETVAL = memcached_create(ptr);
	ST(0) = sv_newmortal();
        /* T_MEMCACHED */
        if (!RETVAL)          /* if null */
            SvOK_off(ST(0)); /* then return as undef instead of reaf to undef */
        else {
            /* setup ST(0) as a ref to a blessed hash hv */
            lmc_state_st *lmc_state;
            HV *hv = newHV();
            const char *classname = "Memcached::libmemcached";
            /* take (sub)class name to use from class_sv if appropriate */
            if (class_sv && SvOK(class_sv) && sv_derived_from(class_sv, classname))
                classname = (SvROK(class_sv)) ? sv_reftype(class_sv, 0) : SvPV_nolen(class_sv);
            sv_setsv(ST(0), sv_2mortal(newRV_noinc((SV*)hv)));
            (void)sv_bless(ST(0), gv_stashpv(classname, TRUE));

            /* allocate an lmc_state struct and attach via MEMCACHED_CALLBACK_USER_DATA */
            lmc_state = lmc_state_new(RETVAL, hv);
            memcached_callback_set(RETVAL, MEMCACHED_CALLBACK_USER_DATA, lmc_state);

            /* now attach RETVAL to the HV */
            /* done as two steps to avoid sv_magic SvREFCNT_inc and MGf_REFCOUNTED */
            sv_magic((SV*)hv, NULL, '~', NULL, 0);
            LMC_STATE_FROM_SV(ST(0)) = (void*)lmc_state;
        }
        if (LMC_TRACE_LEVEL_FROM_PTR(RETVAL) >= 2)
            warn("	<= %s(%s %s = %p)", "memcached_create", "Memcached__libmemcached", "RETVAL", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_clone)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_clone", "clone, source");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 462 "libmemcached.xs"
        SV *class_sv = (items >= 1) ? ST(0) : NULL;
#line 574 "libmemcached.c"
	Memcached__libmemcached	RETVAL;
	Memcached__libmemcached	clone;
	Memcached__libmemcached	source;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            clone = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                clone = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                clone = NULL;
            }
        }
        else
            croak("clone is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(clone) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_clone", "Memcached__libmemcached", "clone", (void*)clone);

        /* T_MEMCACHED */
        if (!SvOK(ST(1))) {  /* undef         */
            source = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(1), "Memcached::libmemcached")) {
            if (SvROK(ST(1))) {
                source = (memcached_st*)LMC_PTR_FROM_SV(ST(1));
            }
            else { /* memcached_st ptr already freed or is a class name */
                source = NULL;
            }
        }
        else
            croak("source is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(source) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_clone", "Memcached__libmemcached", "source", (void*)source);
#line 464 "libmemcached.xs"
        clone = NULL; /* force null even if arg provided */
#line 614 "libmemcached.c"

	RETVAL = memcached_clone(clone, source);
	ST(0) = sv_newmortal();
        /* T_MEMCACHED */
        if (!RETVAL)          /* if null */
            SvOK_off(ST(0)); /* then return as undef instead of reaf to undef */
        else {
            /* setup ST(0) as a ref to a blessed hash hv */
            lmc_state_st *lmc_state;
            HV *hv = newHV();
            const char *classname = "Memcached::libmemcached";
            /* take (sub)class name to use from class_sv if appropriate */
            if (class_sv && SvOK(class_sv) && sv_derived_from(class_sv, classname))
                classname = (SvROK(class_sv)) ? sv_reftype(class_sv, 0) : SvPV_nolen(class_sv);
            sv_setsv(ST(0), sv_2mortal(newRV_noinc((SV*)hv)));
            (void)sv_bless(ST(0), gv_stashpv(classname, TRUE));

            /* allocate an lmc_state struct and attach via MEMCACHED_CALLBACK_USER_DATA */
            lmc_state = lmc_state_new(RETVAL, hv);
            memcached_callback_set(RETVAL, MEMCACHED_CALLBACK_USER_DATA, lmc_state);

            /* now attach RETVAL to the HV */
            /* done as two steps to avoid sv_magic SvREFCNT_inc and MGf_REFCOUNTED */
            sv_magic((SV*)hv, NULL, '~', NULL, 0);
            LMC_STATE_FROM_SV(ST(0)) = (void*)lmc_state;
        }
        if (LMC_TRACE_LEVEL_FROM_PTR(RETVAL) >= 2)
            warn("	<= %s(%s %s = %p)", "memcached_clone", "Memcached__libmemcached", "RETVAL", (void*)RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_server_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_server_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_server_count", "ptr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	RETVAL;
	dXSTARG;
	Memcached__libmemcached	ptr;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_server_count", "Memcached__libmemcached", "ptr", (void*)ptr);

	RETVAL = memcached_server_count(ptr);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_server_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_server_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_server_add", "ptr, hostname, port=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	char *	hostname;
	unsigned int	port;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_server_add", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* treat undef as null pointer (output does the inverse) */
        hostname = (SvOK(ST(1))) ? (char *)SvPV_nolen(ST(1)) : NULL;

	if (items < 3)
	    port = 0;
	else {
	    port = (unsigned int)SvUV(ST(2));
	}

	RETVAL = memcached_server_add(ptr, hostname, port);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_server_add", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_server_add_with_weight); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_server_add_with_weight)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_server_add_with_weight", "ptr, hostname, port=0, weight");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	char *	hostname;
	unsigned int	port;
	unsigned int	weight = (unsigned int)SvUV(ST(3));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_server_add_with_weight", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* treat undef as null pointer (output does the inverse) */
        hostname = (SvOK(ST(1))) ? (char *)SvPV_nolen(ST(1)) : NULL;

	if (items < 3)
	    port = 0;
	else {
	    port = (unsigned int)SvUV(ST(2));
	}

	RETVAL = memcached_server_add_with_weight(ptr, hostname, port, weight);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_server_add_with_weight", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_server_add_unix_socket); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_server_add_unix_socket)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_server_add_unix_socket", "ptr, socket");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	char *	socket;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_server_add_unix_socket", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* treat undef as null pointer (output does the inverse) */
        socket = (SvOK(ST(1))) ? (char *)SvPV_nolen(ST(1)) : NULL;

	RETVAL = memcached_server_add_unix_socket(ptr, socket);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_server_add_unix_socket", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_server_add_unix_socket_with_weight); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_server_add_unix_socket_with_weight)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_server_add_unix_socket_with_weight", "ptr, socket, weight");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	char *	socket;
	unsigned int	weight = (unsigned int)SvUV(ST(2));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_server_add_unix_socket_with_weight", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* treat undef as null pointer (output does the inverse) */
        socket = (SvOK(ST(1))) ? (char *)SvPV_nolen(ST(1)) : NULL;

	RETVAL = memcached_server_add_unix_socket_with_weight(ptr, socket, weight);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_server_add_unix_socket_with_weight", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_free); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_free)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_free", "ptr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Memcached__libmemcached	ptr;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_free", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 485 "libmemcached.xs"
        if (!ptr)   /* garbage or already freed this sv */
            XSRETURN_EMPTY;
#line 970 "libmemcached.c"

	memcached_free(ptr);
#line 488 "libmemcached.xs"
        LMC_STATE_FROM_PTR(ptr)->ptr = NULL;
#line 975 "libmemcached.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Memcached__libmemcached_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::DESTROY", "sv");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0);
#line 493 "libmemcached.xs"
    lmc_state_st *lmc_state;
    lmc_cb_context_st *lmc_cb_context;

    lmc_state = (lmc_state_st*)LMC_STATE_FROM_SV(sv);
    if (lmc_state->trace_level >= 2) {
        warn("DESTROY sv %p, state %p, ptr %p", SvRV(sv), lmc_state, lmc_state->ptr);
        if (lmc_state->trace_level >= 9)
            sv_dump(sv);
    }
    if (lmc_state->ptr)
        memcached_free(lmc_state->ptr);

    lmc_cb_context = lmc_state->cb_context;
    sv_free(lmc_cb_context->get_cb);
    sv_free(lmc_cb_context->set_cb);
    Safefree(lmc_cb_context->key_strings);
    Safefree(lmc_cb_context->key_lengths);

    sv_unmagic(SvRV(sv), '~'); /* disconnect lmc_state from HV */
    Safefree(lmc_state);
#line 1017 "libmemcached.c"
	PUTBACK;
	return;
    }
}


XS(XS_Memcached__libmemcached_memcached_behavior_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_behavior_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_behavior_get", "ptr, flag");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	UV	RETVAL;
	dXSTARG;
	Memcached__libmemcached	ptr;
	memcached_behavior	flag = (memcached_behavior)SvIV(ST(1));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_behavior_get", "Memcached__libmemcached", "ptr", (void*)ptr);

	RETVAL = memcached_behavior_get(ptr, flag);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_behavior_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_behavior_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_behavior_set", "ptr, flag, data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	memcached_behavior	flag = (memcached_behavior)SvIV(ST(1));
	uint64_t	data = (uint64_t)SvNV(ST(2));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_behavior_set", "Memcached__libmemcached", "ptr", (void*)ptr);

	RETVAL = memcached_behavior_set(ptr, flag, data);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_behavior_set", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_callback_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_callback_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_callback_set", "ptr, flag, data");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	memcached_callback	flag = (memcached_callback)SvIV(ST(1));
	SV *	data = ST(2);

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_callback_set", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 523 "libmemcached.xs"
    /* we only allow setting of known-safe flags */
    switch (flag) {
    case MEMCACHED_CALLBACK_PREFIX_KEY:
        RETVAL = memcached_callback_set(ptr, flag, SvPV_nolen(data));
        break;
    default:
        RETVAL = MEMCACHED_FAILURE;
        break;
    }
#line 1164 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_callback_set", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_callback_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_callback_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_callback_get", "ptr, flag, ret=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 538 "libmemcached.xs"
        void *data = NULL;
#line 1200 "libmemcached.c"
	SV *	RETVAL;
	Memcached__libmemcached	ptr;
	memcached_callback	flag = (memcached_callback)SvIV(ST(1));
	memcached_return	ret;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_callback_get", "Memcached__libmemcached", "ptr", (void*)ptr);

	if (items >= 3) {
	/* T_RETURN */
	ret = (SvOK(ST(2))) ? (memcached_return)SvIV(ST(2)) : 0;
	}
#line 540 "libmemcached.xs"
    RETVAL = &PL_sv_undef;
    /* we only allow setting of known-safe flags */
    switch (flag) {
    case MEMCACHED_CALLBACK_PREFIX_KEY:
        data = memcached_callback_get(ptr, flag, &ret);
        /* libmemcached treats empty prefix as an error */
        /* we treat it more pragmatically */
        RETVAL = newSVpv((data) ? data : "", 0);
        break;
    default:
        ret = MEMCACHED_FAILURE;
        break;
    }
#line 1241 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_callback_get", ptr, ret);
	if (items >= 3) {
        /* T_RETURN */
        if (!SvREADONLY(ST(2))) {
            if (LMC_RETURN_OK(ret)) {
                sv_setsv(ST(2), &PL_sv_yes);
            }
            else if (ret == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(2), &PL_sv_no);
            }
            else {
                SvOK_off(ST(2));
            }
        }

	SvSETMAGIC(ST(2));
	}
	ST(0) = sv_newmortal();
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_set", "ptr, key, value, expiration= 0, flags= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_set", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(4))) ? (lmc_data_flags_t)SvUV(ST(4)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(2)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(2), STRLEN_length_of_value);
        };
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_set(ptr, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_set", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_set_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_set_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_set_by_key", "ptr, master_key, key, value, expiration=0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_set_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items < 6)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(5))) ? (lmc_data_flags_t)SvUV(ST(5)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(3)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(3), STRLEN_length_of_value);
        };
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_set_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_set_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_add", "ptr, key, value, expiration= 0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_add", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(4))) ? (lmc_data_flags_t)SvUV(ST(4)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(2)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(2), STRLEN_length_of_value);
        };
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_add(ptr, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_add", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_add_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_add_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_add_by_key", "ptr, master_key, key, value, expiration=0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_add_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items < 6)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(5))) ? (lmc_data_flags_t)SvUV(ST(5)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(3)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(3), STRLEN_length_of_value);
        };
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_add_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_add_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_append); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_append)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_append", "ptr, key, value, expiration= 0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_append", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(4))) ? (lmc_data_flags_t)SvUV(ST(4)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(2)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(2), STRLEN_length_of_value);
        };
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_append(ptr, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_append", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_append_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_append_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_append_by_key", "ptr, master_key, key, value, expiration=0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_append_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items < 6)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(5))) ? (lmc_data_flags_t)SvUV(ST(5)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(3)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(3), STRLEN_length_of_value);
        };
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_append_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_append_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_prepend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_prepend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_prepend", "ptr, key, value, expiration= 0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_prepend", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(4))) ? (lmc_data_flags_t)SvUV(ST(4)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(2)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(2), STRLEN_length_of_value);
        };
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_prepend(ptr, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_prepend", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_prepend_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_prepend_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_prepend_by_key", "ptr, master_key, key, value, expiration=0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_prepend_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items < 6)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(5))) ? (lmc_data_flags_t)SvUV(ST(5)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(3)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(3), STRLEN_length_of_value);
        };
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_prepend_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_prepend_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_replace); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_replace)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_replace", "ptr, key, value, expiration= 0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_replace", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(4))) ? (lmc_data_flags_t)SvUV(ST(4)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(2)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(2), STRLEN_length_of_value);
        };
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_replace(ptr, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_replace", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_replace_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_replace_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_replace_by_key", "ptr, master_key, key, value, expiration=0, flags=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_replace_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items < 6)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(5))) ? (lmc_data_flags_t)SvUV(ST(5)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(3)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(3), STRLEN_length_of_value);
        };
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_replace_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_replace_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_cas); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_cas)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_cas", "ptr, key, value, expiration= 0, flags=0, cas");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;
	uint64_t	cas = (uint64_t)SvNV(ST(5));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_cas", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(4))) ? (lmc_data_flags_t)SvUV(ST(4)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(2)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(2), STRLEN_length_of_value);
        };
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_cas(ptr, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags, cas);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_cas", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_cas_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_cas_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_cas_by_key", "ptr, master_key, key, value, expiration= 0, flags=0, cas");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	STRLEN	STRLEN_length_of_value;
	size_t	XSauto_length_of_value;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_value	value;
	lmc_expiration	expiration;
	lmc_data_flags_t	flags;
	uint64_t	cas = (uint64_t)SvNV(ST(6));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_cas_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

        /* T_VALUE - main code in T_VALUE:pre_call below (so it can access/modify flags) */
        /* mention STRLEN_length_of_value here to keep ParseXS happy for now */;

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items < 6)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(5))) ? (lmc_data_flags_t)SvUV(ST(5)) : 0;
	}
        /* T_VALUE:pre_call */
        if (SvOK(LMC_STATE_FROM_PTR(ptr)->cb_context->set_cb)) {
            /* XXX ignoring flags till we have a better mechanism */
            SV *key_sv, *value_sv, *flags_sv;
            /* these SVs may get cached inside lmc_cb_context_st and reused across calls */
            /* which would save the create,mortalize,destroy costs for each invocation  */
            key_sv   = sv_2mortal(newSVpv(key,   STRLEN_length_of_key));
            value_sv = sv_mortalcopy(ST(3)); /* original SV, as it may be a ref */
            flags_sv = sv_2mortal(newSVuv(flags));
            SvREADONLY_on(key_sv); /* just to be sure for now, may allow later */
            _cb_fire_perl_set_cb(ptr, key_sv, value_sv, flags_sv);
            /* recover possibly modified values (except key) */
            value = SvPV(value_sv, STRLEN_length_of_value);
            flags = SvUV(flags_sv);
        }
        else {
            value = (lmc_value)SvPV(ST(3), STRLEN_length_of_value);
        };
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
	XSauto_length_of_value = STRLEN_length_of_value;

	RETVAL = memcached_cas_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, value, XSauto_length_of_value, expiration, flags, cas);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_cas_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_increment); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_increment)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_increment", "ptr, key, offset, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_increment", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

	if (items >= 4) {
	    value = (uint64_t)SvNV(ST(3));
	}
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_increment(ptr, key, XSauto_length_of_key, offset, &value);
	if (items >= 4) {
	sv_setnv(ST(3), (NV)value);
	SvSETMAGIC(ST(3));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_increment", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_decrement); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_decrement)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_decrement", "ptr, key, offset, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_decrement", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

	if (items >= 4) {
	    value = (uint64_t)SvNV(ST(3));
	}
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_decrement(ptr, key, XSauto_length_of_key, offset, &value);
	if (items >= 4) {
	sv_setnv(ST(3), (NV)value);
	SvSETMAGIC(ST(3));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_decrement", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_increment_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_increment_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_increment_by_key", "ptr, master_key, key, offset, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(3));
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_increment_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

	if (items >= 5) {
	    value = (uint64_t)SvNV(ST(4));
	}
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_increment_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, offset, &value);
	if (items >= 5) {
	sv_setnv(ST(4), (NV)value);
	SvSETMAGIC(ST(4));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_increment_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_decrement_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_decrement_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_decrement_by_key", "ptr, master_key, key, offset, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(3));
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_decrement_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

	if (items >= 5) {
	    value = (uint64_t)SvNV(ST(4));
	}
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_decrement_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, offset, &value);
	if (items >= 5) {
	sv_setnv(ST(4), (NV)value);
	SvSETMAGIC(ST(4));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_decrement_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_increment_with_initial); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_increment_with_initial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_increment_with_initial", "ptr, key, offset, initial, expiration= 0, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	uint64_t	initial = (uint64_t)SvNV(ST(3));
	lmc_expiration	expiration;
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_increment_with_initial", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items >= 6) {
	    value = (uint64_t)SvNV(ST(5));
	}
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_increment_with_initial(ptr, key, XSauto_length_of_key, offset, initial, expiration, &value);
	if (items >= 6) {
	sv_setnv(ST(5), (NV)value);
	SvSETMAGIC(ST(5));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_increment_with_initial", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_decrement_with_initial); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_decrement_with_initial)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_decrement_with_initial", "ptr, key, offset, initial, expiration= 0, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	uint64_t	initial = (uint64_t)SvNV(ST(3));
	lmc_expiration	expiration;
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_decrement_with_initial", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

	if (items < 5)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(4))) ? (lmc_expiration)SvUV(ST(4)) : 0;
	}

	if (items >= 6) {
	    value = (uint64_t)SvNV(ST(5));
	}
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_decrement_with_initial(ptr, key, XSauto_length_of_key, offset, initial, expiration, &value);
	if (items >= 6) {
	sv_setnv(ST(5), (NV)value);
	SvSETMAGIC(ST(5));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_decrement_with_initial", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_increment_with_initial_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_increment_with_initial_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_increment_with_initial_by_key", "ptr, master_key, key, offset, initial, expiration= 0, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(3));
	uint64_t	initial = (uint64_t)SvNV(ST(4));
	lmc_expiration	expiration;
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_increment_with_initial_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

	if (items < 6)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(5))) ? (lmc_expiration)SvUV(ST(5)) : 0;
	}

	if (items >= 7) {
	    value = (uint64_t)SvNV(ST(6));
	}
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_increment_with_initial_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, offset, initial, expiration, &value);
	if (items >= 7) {
	sv_setnv(ST(6), (NV)value);
	SvSETMAGIC(ST(6));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_increment_with_initial_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_decrement_with_initial_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_decrement_with_initial_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 5 || items > 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_decrement_with_initial_by_key", "ptr, master_key, key, offset, initial, expiration= 0, value=NO_INIT");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	unsigned int	offset = (unsigned int)SvUV(ST(3));
	uint64_t	initial = (uint64_t)SvNV(ST(4));
	lmc_expiration	expiration;
	uint64_t	value;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_decrement_with_initial_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

	if (items < 6)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(5))) ? (lmc_expiration)SvUV(ST(5)) : 0;
	}

	if (items >= 7) {
	    value = (uint64_t)SvNV(ST(6));
	}
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_decrement_with_initial_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, offset, initial, expiration, &value);
	if (items >= 7) {
	sv_setnv(ST(6), (NV)value);
	SvSETMAGIC(ST(6));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_decrement_with_initial_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_get", "ptr, key, flags=0, error=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_data_flags_t	flags;
	memcached_return	error;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_get", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

	if (items < 3)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(2))) ? (lmc_data_flags_t)SvUV(ST(2)) : 0;
	}

	if (items < 4)
	    error = 0;
	else {
	/* T_RETURN */
	error = (SvOK(ST(3))) ? (memcached_return)SvIV(ST(3)) : 0;
	}
	XSauto_length_of_key = STRLEN_length_of_key;
#line 711 "libmemcached.xs"
        /* rc is the return code from the preceeding mget */
        error = memcached_mget_by_key(ptr, NULL, 0, (const char * const*)&key, &XSauto_length_of_key, 1);
        RETVAL = _fetch_one_sv(ptr, &flags, &error);
#line 3225 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_get", ptr, error);
	if (items >= 4) {
        /* T_RETURN */
        if (!SvREADONLY(ST(3))) {
            if (LMC_RETURN_OK(error)) {
                sv_setsv(ST(3), &PL_sv_yes);
            }
            else if (error == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(3), &PL_sv_no);
            }
            else {
                SvOK_off(ST(3));
            }
        }

	SvSETMAGIC(ST(3));
	}
	if (items >= 3) {
        /* T_FLAGS */
        if (!SvREADONLY(ST(2)))
            sv_setuv(ST(2), (UV)flags);

	SvSETMAGIC(ST(2));
	}
	ST(0) = sv_newmortal();
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_get_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_get_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_get_by_key", "ptr, master_key, key, flags=0, error=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_data_flags_t	flags;
	memcached_return	error;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_get_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

	if (items < 4)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(3))) ? (lmc_data_flags_t)SvUV(ST(3)) : 0;
	}

	if (items < 5)
	    error = 0;
	else {
	/* T_RETURN */
	error = (SvOK(ST(4))) ? (memcached_return)SvIV(ST(4)) : 0;
	}
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;
#line 725 "libmemcached.xs"
        error = memcached_mget_by_key(ptr, master_key, XSauto_length_of_master_key, (const char * const*)&key, &XSauto_length_of_key, 1);
        RETVAL = _fetch_one_sv(ptr, &flags, &error);
#line 3322 "libmemcached.c"
	if (items >= 4) {
        /* T_FLAGS */
        if (!SvREADONLY(ST(3)))
            sv_setuv(ST(3), (UV)flags);

	SvSETMAGIC(ST(3));
	}
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_get_by_key", ptr, error);
	if (items >= 5) {
        /* T_RETURN */
        if (!SvREADONLY(ST(4))) {
            if (LMC_RETURN_OK(error)) {
                sv_setsv(ST(4), &PL_sv_yes);
            }
            else if (error == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(4), &PL_sv_no);
            }
            else {
                SvOK_off(ST(4));
            }
        }

	SvSETMAGIC(ST(4));
	}
	ST(0) = sv_newmortal();
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_mget); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_mget)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_mget", "ptr, keys_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 734 "libmemcached.xs"
        char **keys;
        size_t *key_length;
        unsigned int number_of_keys;
#line 3371 "libmemcached.c"
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	SV *	keys_rv = ST(1);

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_mget", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 738 "libmemcached.xs"
        if ((RETVAL = _prep_keys_lengths(ptr, keys_rv, &keys, &key_length, &number_of_keys)) == MEMCACHED_SUCCESS) {
            RETVAL = memcached_mget(ptr, (const char * const*)keys, key_length, number_of_keys);
        }
#line 3396 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_mget", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_mget_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_mget_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_mget_by_key", "ptr, master_key, keys_rv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 747 "libmemcached.xs"
        char **keys;
        size_t *key_length;
        unsigned int number_of_keys;
#line 3434 "libmemcached.c"
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	SV *	keys_rv = ST(2);

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_mget_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
#line 751 "libmemcached.xs"
        if ((RETVAL = _prep_keys_lengths(ptr, keys_rv, &keys, &key_length, &number_of_keys)) == MEMCACHED_SUCCESS) {
            RETVAL = memcached_mget_by_key(ptr, master_key, XSauto_length_of_master_key, (const char * const*)keys, key_length, number_of_keys);
        }
#line 3466 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_mget_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_fetch); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_fetch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_fetch", "ptr, key, flags=0, error=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 765 "libmemcached.xs"
        size_t key_length=0;
        size_t value_length=0;
        char key_buffer[MEMCACHED_MAX_KEY];
#line 3504 "libmemcached.c"
	lmc_value	RETVAL;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_data_flags_t	flags;
	memcached_return	error;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_fetch", "Memcached__libmemcached", "ptr", (void*)ptr);

	if (items < 3)
	    flags = 0;
	else {
	/* T_FLAGS */
	flags = (SvOK(ST(2))) ? (lmc_data_flags_t)SvUV(ST(2)) : 0;
	}

	if (items < 4)
	    error = 0;
	else {
	/* T_RETURN */
	error = (SvOK(ST(3))) ? (memcached_return)SvIV(ST(3)) : 0;
	}
#line 769 "libmemcached.xs"
        key = key_buffer;
#line 3543 "libmemcached.c"
#line 771 "libmemcached.xs"
        RETVAL = memcached_fetch(ptr, key, &key_length, &value_length, &flags, &error);
#line 3546 "libmemcached.c"
        /* T_KEY */
        /* assumes the existance of a key_length variable holding the length */
        if (!SvREADONLY(ST(1)))
            sv_setpvn((SV*)ST(1), key, key_length);

	SvSETMAGIC(ST(1));
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_fetch", ptr, error);
	if (items >= 4) {
        /* T_RETURN */
        if (!SvREADONLY(ST(3))) {
            if (LMC_RETURN_OK(error)) {
                sv_setsv(ST(3), &PL_sv_yes);
            }
            else if (error == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(3), &PL_sv_no);
            }
            else {
                SvOK_off(ST(3));
            }
        }

	SvSETMAGIC(ST(3));
	}
	if (items >= 3) {
        /* T_FLAGS */
        if (!SvREADONLY(ST(2)))
            sv_setuv(ST(2), (UV)flags);

	SvSETMAGIC(ST(2));
	}
	ST(0) = sv_newmortal();
        /* T_VALUE */
        /* assumes the existance of a value_length variable holding the length */
        if (!SvREADONLY(ST(0)))
            sv_setpvn((SV*)ST(0), RETVAL, value_length);

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_delete", "ptr, key, expiration= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	key;
	lmc_expiration	expiration;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_delete", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(1), STRLEN_length_of_key);

	if (items < 3)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(2))) ? (lmc_expiration)SvUV(ST(2)) : 0;
	}
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_delete(ptr, key, XSauto_length_of_key, expiration);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_delete", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_delete_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_delete_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_delete_by_key", "ptr, master_key, key, expiration= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	STRLEN	STRLEN_length_of_master_key;
	size_t	XSauto_length_of_master_key;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	Memcached__libmemcached	ptr;
	lmc_key	master_key;
	lmc_key	key;
	lmc_expiration	expiration;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_delete_by_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_KEY */
        master_key = (lmc_key)SvPV(ST(1), STRLEN_length_of_master_key);

        /* T_KEY */
        key = (lmc_key)SvPV(ST(2), STRLEN_length_of_key);

	if (items < 4)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(3))) ? (lmc_expiration)SvUV(ST(3)) : 0;
	}
	XSauto_length_of_master_key = STRLEN_length_of_master_key;
	XSauto_length_of_key = STRLEN_length_of_key;

	RETVAL = memcached_delete_by_key(ptr, master_key, XSauto_length_of_master_key, key, XSauto_length_of_key, expiration);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_delete_by_key", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_verbosity); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_verbosity)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_verbosity", "ptr, verbosity");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	unsigned int	verbosity = (unsigned int)SvUV(ST(1));

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_verbosity", "Memcached__libmemcached", "ptr", (void*)ptr);

	RETVAL = memcached_verbosity(ptr, verbosity);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_verbosity", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_flush", "ptr, expiration=0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	lmc_expiration	expiration;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_flush", "Memcached__libmemcached", "ptr", (void*)ptr);

	if (items < 2)
	    expiration = 0;
	else {
	/* T_EXPIRATION */
	expiration = (SvOK(ST(1))) ? (lmc_expiration)SvUV(ST(1)) : 0;
	}

	RETVAL = memcached_flush(ptr, expiration);
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("memcached_flush", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_quit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_quit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_quit", "ptr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Memcached__libmemcached	ptr;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_quit", "Memcached__libmemcached", "ptr", (void*)ptr);

	memcached_quit(ptr);
    }
    XSRETURN_EMPTY;
}


XS(XS_Memcached__libmemcached_memcached_strerror); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_strerror)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_strerror", "ptr, rc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
	Memcached__libmemcached	ptr;
	memcached_return	rc;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "memcached_strerror", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* T_RETURN */
        rc = (SvOK(ST(1))) ? (memcached_return)SvIV(ST(1)) : 0;

	RETVAL = memcached_strerror(ptr, rc);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_memcached_lib_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_memcached_lib_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::memcached_lib_version", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = memcached_lib_version();
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_trace_level); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_trace_level)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::trace_level", "ptr, level= IV_MIN");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 837 "libmemcached.xs"
        lmc_state_st* lmc_state;
#line 3968 "libmemcached.c"
	IV	RETVAL;
	dXSTARG;
	Memcached__libmemcached	ptr;
	IV	level;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "trace_level", "Memcached__libmemcached", "ptr", (void*)ptr);

	if (items < 2)
	    level = IV_MIN;
	else {
	    level = (IV)SvIV(ST(1));
	}
#line 839 "libmemcached.xs"
        lmc_state = LMC_STATE_FROM_PTR(ptr);
        RETVAL = LMC_TRACE_LEVEL_FROM_PTR(ptr); /* return previous level */
        if (level != IV_MIN && lmc_state)
            lmc_state->trace_level = level;
#line 4001 "libmemcached.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_errstr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_errstr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "ptr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 852 "libmemcached.xs"
        lmc_state_st* lmc_state;
#line 4023 "libmemcached.c"
	SV *	RETVAL;
	Memcached__libmemcached	ptr;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "errstr", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 854 "libmemcached.xs"
        if (!ptr)
            XSRETURN_UNDEF;
        PERL_UNUSED_VAR(ix);
        RETVAL = newSV(0);
        lmc_state = LMC_STATE_FROM_PTR(ptr);
        /* setup return value as a dualvar with int err code and string error message */
        sv_setiv(RETVAL, lmc_state->last_return);
        sv_setpv(RETVAL, memcached_strerror(ptr, lmc_state->last_return));
        if (lmc_state->last_return == MEMCACHED_ERRNO) {
            /* lmc_state->last_errno should be meaningful here but sometimes isn't */
            /* See https://rt.cpan.org/Ticket/Display.html?id=41299 */
            sv_catpvf(RETVAL, " %s", (lmc_state->last_errno) ? strerror(lmc_state->last_errno) : "(last_errno==0!)");
        }
        SvIOK_on(RETVAL); /* set as dualvar */
#line 4058 "libmemcached.c"
	ST(0) = sv_newmortal();
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::get", "ptr, key_sv");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 875 "libmemcached.xs"
        char *master_key = NULL;
        size_t master_key_len = 0;
        char *key;
        size_t key_len;
        memcached_return error;
        uint32_t flags;
#line 4085 "libmemcached.c"
	SV *	RETVAL;
	Memcached__libmemcached	ptr;
	SV *	key_sv = ST(1);

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "get", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 882 "libmemcached.xs"
        if (SvROK(key_sv) && SvTYPE(SvRV(key_sv)) == SVt_PVAV) {
            AV *av = (AV*)SvRV(key_sv);
            master_key = SvPV(AvARRAY(av)[0], master_key_len);
            key_sv = AvARRAY(av)[1];
            warn("get with array ref as key is deprecated");
        }
        key = SvPV(key_sv, key_len);
        error = memcached_mget_by_key(ptr, master_key, master_key_len, (const char * const*)&key, &key_len, 1);
        RETVAL = _fetch_one_sv(ptr, &flags, &error);
#line 4116 "libmemcached.c"
	ST(0) = sv_newmortal();
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_get_multi); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_get_multi)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::get_multi", "ptr, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 898 "libmemcached.xs"
        HV *hv = newHV();
        SV *dest_ref = sv_2mortal(newRV_noinc((SV*)hv));
        char **keys;
        size_t *key_length;
        unsigned int number_of_keys = --items;
        memcached_return ret;
        lmc_cb_context_st *lmc_cb_context;
#line 4146 "libmemcached.c"
	Memcached__libmemcached	ptr;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "get_multi", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 906 "libmemcached.xs"
        /* XXX does not support keys being [ $master_key, $key ] */
        lmc_cb_context = LMC_STATE_FROM_PTR(ptr)->cb_context;

        if (number_of_keys > lmc_cb_context->key_alloc_count)
            _prep_keys_buffer(lmc_cb_context, number_of_keys);
        keys       = lmc_cb_context->key_strings;
        key_length = lmc_cb_context->key_lengths;
        while (--items >= 0) {
            keys[items] = SvPV(ST(items+1), key_length[items]);
        }

        ret = memcached_mget(ptr, (const char * const*)keys, key_length, number_of_keys);
        _fetch_all_into_hashref(ptr, ret, hv);
        if (lmc_cb_context->lmc_state->trace_level)
            warn("get_multi of %d keys: mget %s, fetched %d",
                number_of_keys, memcached_strerror(ptr,ret), (int)lmc_cb_context->result_count);
        PUSHs(dest_ref);
        XSRETURN(1);
#line 4184 "libmemcached.c"
	PUTBACK;
	return;
    }
}


XS(XS_Memcached__libmemcached_mget_into_hashref); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_mget_into_hashref)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "ptr, keys_ref, dest_ref");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 932 "libmemcached.xs"
        char **keys;
        size_t *key_length;
        unsigned int number_of_keys;
#line 4208 "libmemcached.c"
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	SV *	keys_ref = ST(1);
	HV *	dest_ref;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "mget_into_hashref", "Memcached__libmemcached", "ptr", (void*)ptr);

    if (!SvROK(ST(2)) || !SvTYPE(SvRV(ST(2)))==SVt_PVHV)
        Perl_croak(aTHX_ "dest_ref is not a hash reference");
    dest_ref = (HV*)SvRV(ST(2));
#line 936 "libmemcached.xs"
        PERL_UNUSED_VAR(ix);
        if ((RETVAL = _prep_keys_lengths(ptr, keys_ref, &keys, &key_length, &number_of_keys)) == MEMCACHED_SUCCESS) {
            RETVAL = memcached_mget(ptr, (const char * const*)keys, key_length, number_of_keys);
            RETVAL = _fetch_all_into_hashref(ptr, RETVAL, dest_ref);
        }
#line 4240 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("mget_into_hashref", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_set_callback_coderefs); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_set_callback_coderefs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "ptr, set_cb, get_cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 950 "libmemcached.xs"
        lmc_state_st *lmc_state;
#line 4277 "libmemcached.c"
	Memcached__libmemcached	ptr;
	SV *	set_cb = ST(1);
	SV *	get_cb = ST(2);

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "set_callback_coderefs", "Memcached__libmemcached", "ptr", (void*)ptr);
#line 952 "libmemcached.xs"
        PERL_UNUSED_VAR(ix);
        if (SvOK(set_cb) && !(SvROK(set_cb) && SvTYPE(SvRV(set_cb)) == SVt_PVCV))
            croak("set_cb is not a reference to a subroutine");
        if (SvOK(get_cb) && !(SvROK(get_cb) && SvTYPE(SvRV(get_cb)) == SVt_PVCV))
            croak("get_cb is not a reference to a subroutine");
        lmc_state = LMC_STATE_FROM_PTR(ptr);
        sv_setsv(lmc_state->cb_context->set_cb, set_cb);
        sv_setsv(lmc_state->cb_context->get_cb, get_cb);
#line 4307 "libmemcached.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Memcached__libmemcached_walk_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_walk_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::walk_stats", "ptr, stats_args, cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 965 "libmemcached.xs"
        Memcached__libmemcached clone;
#line 4327 "libmemcached.c"
	memcached_return	RETVAL;
	Memcached__libmemcached	ptr;
	SV *	stats_args = ST(1);
	CV *	cb;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "walk_stats", "Memcached__libmemcached", "ptr", (void*)ptr);

	STMT_START {
                HV *st;
                GV *gvp;
		SV * const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
                cb = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		if (!cb) {
		    Perl_croak_nocontext("%s: %s is not a CODE reference",
				"Memcached::libmemcached::walk_stats",
				"cb");
		}
	} STMT_END;
#line 967 "libmemcached.xs"
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("walk_stats(%s, %s)\n", SvPV_nolen(stats_args), SvPV_nolen((SV*)CvGV(cb)));

        clone = memcached_clone(NULL, ptr);
        memcached_behavior_set(clone, MEMCACHED_BEHAVIOR_BINARY_PROTOCOL, 0);

        ENTER;
        SAVETMPS;

        /* this local($_) assignment is to aid migration from the old api */
        SAVE_DEFSV; /* local($_) */
        DEFSV = sv_mortalcopy(stats_args);

        RETVAL = memcached_stat_execute(clone, SvPV_nolen(stats_args), _walk_stats_cb, cb);
        if (!LMC_RETURN_OK(RETVAL)) {
            LMC_RECORD_RETURN_ERR("memcached_stat_execute", ptr, RETVAL);
            LMC_STATE_FROM_PTR(ptr)->last_errno = memcached_last_error_errno(clone);
            memcached_free(clone);
            XSRETURN_NO;
        }
        memcached_free(clone);

        FREETMPS;
        LEAVE;
#line 4387 "libmemcached.c"
        /* T_RETURN:init */
        LMC_RECORD_RETURN_ERR("walk_stats", ptr, RETVAL);
	ST(0) = sv_newmortal();
        /* T_RETURN */
        if (!SvREADONLY(ST(0))) {
            if (LMC_RETURN_OK(RETVAL)) {
                sv_setsv(ST(0), &PL_sv_yes);
            }
            else if (RETVAL == MEMCACHED_NOTFOUND) {
                sv_setsv(ST(0), &PL_sv_no);
            }
            else {
                SvOK_off(ST(0));
            }
        }

    }
    XSRETURN(1);
}


XS(XS_Memcached__libmemcached_get_server_for_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Memcached__libmemcached_get_server_for_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Memcached::libmemcached::get_server_for_key", "ptr, key");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	RETVAL;
	Memcached__libmemcached	ptr;
	char *	key;

        /* T_MEMCACHED */
        if (!SvOK(ST(0))) {  /* undef         */
            ptr = NULL;    /* treat as null */
        }
        else if (sv_derived_from(ST(0), "Memcached::libmemcached")) {
            if (SvROK(ST(0))) {
                ptr = (memcached_st*)LMC_PTR_FROM_SV(ST(0));
            }
            else { /* memcached_st ptr already freed or is a class name */
                ptr = NULL;
            }
        }
        else
            croak("ptr is not of type Memcached::libmemcached");
        if (LMC_TRACE_LEVEL_FROM_PTR(ptr) >= 2)
            warn("	=> %s(%s %s = 0x%p)", "get_server_for_key", "Memcached__libmemcached", "ptr", (void*)ptr);

        /* treat undef as null pointer (output does the inverse) */
        key = (SvOK(ST(1))) ? (char *)SvPV_nolen(ST(1)) : NULL;
#line 996 "libmemcached.xs"
        memcached_return_t err;
        const memcached_instance_st *sp = memcached_server_by_key(ptr, key, strlen(key), &err);
        if (sp == NULL)
            XSRETURN_UNDEF;

        RETVAL = newSVpvf("%s:%d",
            memcached_server_name(sp),
            memcached_server_port(sp)
        );
        /* memcached_instance_free(sp); ??? */

#line 4456 "libmemcached.c"
	ST(0) = sv_newmortal();
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Memcached__libmemcached); /* prototype to pass -Wmissing-prototypes */
XS(boot_Memcached__libmemcached)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        cv = newXS("Memcached::libmemcached::MEMCACHED_INVALID_HOST_PROTOCOL", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_INVALID_HOST_PROTOCOL ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_HASH_WITH_PREFIX_KEY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_HASH_WITH_PREFIX_KEY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_STRIDE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_STRIDE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_USE_UDP", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_USE_UDP ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_KETAMA_HASH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_KETAMA_HASH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_MODULA", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_MODULA ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SUPPORT_CAS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SUPPORT_CAS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_MARKED_DEAD", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_MARKED_DEAD ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BAD_KEY_PROVIDED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BAD_KEY_PROVIDED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_END", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_END ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_UNKNOWN_READ_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_UNKNOWN_READ_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_DELETE_TRIGGER", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_DELETE_TRIGGER ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_POINTS_PER_SERVER", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_POINTS_PER_SERVER ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_MAX", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_MAX ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_PARTIAL_READ", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_PARTIAL_READ ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SOCKET_SEND_SIZE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SOCKET_SEND_SIZE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_MAX_KEY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_MAX_KEY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SERVER_FAILURE_LIMIT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SERVER_FAILURE_LIMIT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_ITEM", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_ITEM ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONNECTION_SOCKET_CREATE_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONNECTION_SOCKET_CREATE_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_CLEANUP_FUNCTION", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_CLEANUP_FUNCTION ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_RANDOMIZE_REPLICA_READ", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_RANDOMIZE_REPLICA_READ ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_VERIFY_KEY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_VERIFY_KEY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_MD5", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_MD5 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_VERSION_STRING_LENGTH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_VERSION_STRING_LENGTH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_ERRNO", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_ERRNO ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_CRC", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_CRC ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_IO_KEY_PREFETCH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_IO_KEY_PREFETCH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SORT_HOSTS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SORT_HOSTS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_FAILURE_RETRY_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_FAILURE_RETRY_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_TCP_KEEPALIVE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_TCP_KEEPALIVE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SERVER_TIMEOUT_LIMIT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SERVER_TIMEOUT_LIMIT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_DEFAULT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_DEFAULT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_IO_MSG_WATERMARK", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_IO_MSG_WATERMARK ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_FNV1A_32", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_FNV1A_32 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_REMOVE_FAILED_SERVERS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_REMOVE_FAILED_SERVERS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DEFAULT_PORT_STRING", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DEFAULT_PORT_STRING ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_NAMESPACE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_NAMESPACE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_MURMUR3", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_MURMUR3 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HOST_LOOKUP_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HOST_LOOKUP_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_MEMORY_ALLOCATION_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_MEMORY_ALLOCATION_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_RANDOM", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_RANDOM ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_CORK", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_CORK ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONNECTION_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONNECTION_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_FNV1_32", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_FNV1_32 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_AUTH_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_AUTH_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_TCP_NODELAY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_TCP_NODELAY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_PARSE_ERROR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_PARSE_ERROR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_CONSISTENT_KETAMA", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_CONSISTENT_KETAMA ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_STORED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_STORED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_PREFIX_KEY_MAX_SIZE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_PREFIX_KEY_MAX_SIZE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_PREFIX_KEY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_PREFIX_KEY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_NOT_SUPPORTED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_NOT_SUPPORTED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_NOTSTORED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_NOTSTORED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_EXPIRATION_NOT_ADD", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_EXPIRATION_NOT_ADD ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_TCP_KEEPIDLE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_TCP_KEEPIDLE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_MURMUR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_MURMUR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONNECTION_TCP", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONNECTION_TCP ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_GET_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_GET_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_MAX", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_MAX ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONNECTION_UNIX_SOCKET", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONNECTION_UNIX_SOCKET ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_HSIEH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_HSIEH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_NOTFOUND", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_NOTFOUND ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_TIMEOUT_LIMIT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_TIMEOUT_LIMIT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_NO_BLOCK", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_NO_BLOCK ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_NO_SERVERS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_NO_SERVERS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_MEMORY_ALLOCATION_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_MEMORY_ALLOCATION_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONTINUUM_SIZE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONTINUUM_SIZE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_CONSISTENT_MAX", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_CONSISTENT_MAX ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_USER_DATA", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_USER_DATA ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_FNV1_64", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_FNV1_64 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_CUSTOM", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_CUSTOM ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DEFAULT_PORT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DEFAULT_PORT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_CONNECT_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_CONNECT_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_AUTH_CONTINUE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_AUTH_CONTINUE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONNECTION_UDP", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONNECTION_UDP ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SOCKET_RECV_SIZE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SOCKET_RECV_SIZE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DEFAULT_CONNECT_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DEFAULT_CONNECT_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_NUMBER_OF_REPLICAS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_NUMBER_OF_REPLICAS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_ERROR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_ERROR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_MAX_BUFFER", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_MAX_BUFFER ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_RETRY_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_RETRY_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DATA_DOES_NOT_EXIST", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DATA_DOES_NOT_EXIST ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_SND_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_SND_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONTINUUM_ADDITION", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONTINUUM_ADDITION ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_USER_DATA", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_USER_DATA ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_CONSISTENT_KETAMA_SPY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_CONSISTENT_KETAMA_SPY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_MAXIMUM_RETURN", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_MAXIMUM_RETURN ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_PARSE_USER_ERROR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_PARSE_USER_ERROR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SUCCESS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SUCCESS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_IN_PROGRESS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_IN_PROGRESS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_BUFFER_REQUESTS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_BUFFER_REQUESTS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_POINTS_PER_SERVER_KETAMA", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_POINTS_PER_SERVER_KETAMA ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_TEMPORARILY_DISABLED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_TEMPORARILY_DISABLED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_FETCH_NOTFINISHED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_FETCH_NOTFINISHED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DEFAULT_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DEFAULT_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_KETAMA_WEIGHTED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_KETAMA_WEIGHTED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_READ_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_READ_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_E2BIG", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_E2BIG ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_FAIL_UNIX_SOCKET", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_FAIL_UNIX_SOCKET ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CONNECTION_BIND_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CONNECTION_BIND_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_STAT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_STAT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_BINARY_PROTOCOL", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_BINARY_PROTOCOL ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_VIRTUAL_BUCKET", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_VIRTUAL_BUCKET ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_PROTOCOL_ERROR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_PROTOCOL_ERROR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_MAXIMUM_INTEGER_DISPLAY_LENGTH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_MAXIMUM_INTEGER_DISPLAY_LENGTH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CLIENT_ERROR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CLIENT_ERROR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_POLL_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_POLL_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DELETED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DELETED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_CALLBACK_CLONE_FUNCTION", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_CALLBACK_CLONE_FUNCTION ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_INVALID_ARGUMENTS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_INVALID_ARGUMENTS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_JENKINS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_JENKINS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_FAILURE_DEAD_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_FAILURE_DEAD_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_DISTRIBUTION", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_DISTRIBUTION ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SOME_ERRORS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SOME_ERRORS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_KEY_TOO_BIG", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_KEY_TOO_BIG ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_HASH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_HASH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_UNKNOWN_STAT_KEY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_UNKNOWN_STAT_KEY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_RCV_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_RCV_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_NO_KEY_PROVIDED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_NO_KEY_PROVIDED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_NOREPLY", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_NOREPLY ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_FAILURE_LIMIT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_FAILURE_LIMIT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_KETAMA", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_KETAMA ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_DEAD_TIMEOUT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_DEAD_TIMEOUT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_AUTH_PROBLEM", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_AUTH_PROBLEM ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_CONSISTENT_WEIGHTED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_CONSISTENT_WEIGHTED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_FNV1A_64", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_FNV1A_64 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_VALUE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_VALUE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_CACHE_LOOKUPS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_CACHE_LOOKUPS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_WRITE_FAILURE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_WRITE_FAILURE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_IO_BYTES_WATERMARK", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_IO_BYTES_WATERMARK ;
        cv = newXS("Memcached::libmemcached::constant", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BUFFERED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BUFFERED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_MAX_HOST_SORT_LENGTH", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_MAX_HOST_SORT_LENGTH ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DISTRIBUTION_CONSISTENT", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DISTRIBUTION_CONSISTENT ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DEPRECATED", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DEPRECATED ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_LOAD_FROM_FILE", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_LOAD_FROM_FILE ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_DATA_EXISTS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_DATA_EXISTS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_BEHAVIOR_AUTO_EJECT_HOSTS", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_BEHAVIOR_AUTO_EJECT_HOSTS ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_SERVER_ERROR", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_SERVER_ERROR ;
        cv = newXS("Memcached::libmemcached::MEMCACHED_HASH_MAX", XS_Memcached__libmemcached_constant, file);
        XSANY.any_i32 = MEMCACHED_HASH_MAX ;
        cv = newXS("Memcached::libmemcached::memcached_create", XS_Memcached__libmemcached_memcached_create, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Memcached::libmemcached::new", XS_Memcached__libmemcached_memcached_create, file);
        XSANY.any_i32 = 1 ;
        newXS("Memcached::libmemcached::memcached_clone", XS_Memcached__libmemcached_memcached_clone, file);
        newXS("Memcached::libmemcached::memcached_server_count", XS_Memcached__libmemcached_memcached_server_count, file);
        newXS("Memcached::libmemcached::memcached_server_add", XS_Memcached__libmemcached_memcached_server_add, file);
        newXS("Memcached::libmemcached::memcached_server_add_with_weight", XS_Memcached__libmemcached_memcached_server_add_with_weight, file);
        newXS("Memcached::libmemcached::memcached_server_add_unix_socket", XS_Memcached__libmemcached_memcached_server_add_unix_socket, file);
        newXS("Memcached::libmemcached::memcached_server_add_unix_socket_with_weight", XS_Memcached__libmemcached_memcached_server_add_unix_socket_with_weight, file);
        newXS("Memcached::libmemcached::memcached_free", XS_Memcached__libmemcached_memcached_free, file);
        newXS("Memcached::libmemcached::DESTROY", XS_Memcached__libmemcached_DESTROY, file);
        newXS("Memcached::libmemcached::memcached_behavior_get", XS_Memcached__libmemcached_memcached_behavior_get, file);
        newXS("Memcached::libmemcached::memcached_behavior_set", XS_Memcached__libmemcached_memcached_behavior_set, file);
        newXS("Memcached::libmemcached::memcached_callback_set", XS_Memcached__libmemcached_memcached_callback_set, file);
        newXS("Memcached::libmemcached::memcached_callback_get", XS_Memcached__libmemcached_memcached_callback_get, file);
        newXS("Memcached::libmemcached::memcached_set", XS_Memcached__libmemcached_memcached_set, file);
        newXS("Memcached::libmemcached::memcached_set_by_key", XS_Memcached__libmemcached_memcached_set_by_key, file);
        newXS("Memcached::libmemcached::memcached_add", XS_Memcached__libmemcached_memcached_add, file);
        newXS("Memcached::libmemcached::memcached_add_by_key", XS_Memcached__libmemcached_memcached_add_by_key, file);
        newXS("Memcached::libmemcached::memcached_append", XS_Memcached__libmemcached_memcached_append, file);
        newXS("Memcached::libmemcached::memcached_append_by_key", XS_Memcached__libmemcached_memcached_append_by_key, file);
        newXS("Memcached::libmemcached::memcached_prepend", XS_Memcached__libmemcached_memcached_prepend, file);
        newXS("Memcached::libmemcached::memcached_prepend_by_key", XS_Memcached__libmemcached_memcached_prepend_by_key, file);
        newXS("Memcached::libmemcached::memcached_replace", XS_Memcached__libmemcached_memcached_replace, file);
        newXS("Memcached::libmemcached::memcached_replace_by_key", XS_Memcached__libmemcached_memcached_replace_by_key, file);
        newXS("Memcached::libmemcached::memcached_cas", XS_Memcached__libmemcached_memcached_cas, file);
        newXS("Memcached::libmemcached::memcached_cas_by_key", XS_Memcached__libmemcached_memcached_cas_by_key, file);
        newXS("Memcached::libmemcached::memcached_increment", XS_Memcached__libmemcached_memcached_increment, file);
        newXS("Memcached::libmemcached::memcached_decrement", XS_Memcached__libmemcached_memcached_decrement, file);
        newXS("Memcached::libmemcached::memcached_increment_by_key", XS_Memcached__libmemcached_memcached_increment_by_key, file);
        newXS("Memcached::libmemcached::memcached_decrement_by_key", XS_Memcached__libmemcached_memcached_decrement_by_key, file);
        newXS("Memcached::libmemcached::memcached_increment_with_initial", XS_Memcached__libmemcached_memcached_increment_with_initial, file);
        newXS("Memcached::libmemcached::memcached_decrement_with_initial", XS_Memcached__libmemcached_memcached_decrement_with_initial, file);
        newXS("Memcached::libmemcached::memcached_increment_with_initial_by_key", XS_Memcached__libmemcached_memcached_increment_with_initial_by_key, file);
        newXS("Memcached::libmemcached::memcached_decrement_with_initial_by_key", XS_Memcached__libmemcached_memcached_decrement_with_initial_by_key, file);
        newXS("Memcached::libmemcached::memcached_get", XS_Memcached__libmemcached_memcached_get, file);
        newXS("Memcached::libmemcached::memcached_get_by_key", XS_Memcached__libmemcached_memcached_get_by_key, file);
        newXS("Memcached::libmemcached::memcached_mget", XS_Memcached__libmemcached_memcached_mget, file);
        newXS("Memcached::libmemcached::memcached_mget_by_key", XS_Memcached__libmemcached_memcached_mget_by_key, file);
        newXS("Memcached::libmemcached::memcached_fetch", XS_Memcached__libmemcached_memcached_fetch, file);
        newXS("Memcached::libmemcached::memcached_delete", XS_Memcached__libmemcached_memcached_delete, file);
        newXS("Memcached::libmemcached::memcached_delete_by_key", XS_Memcached__libmemcached_memcached_delete_by_key, file);
        newXS("Memcached::libmemcached::memcached_verbosity", XS_Memcached__libmemcached_memcached_verbosity, file);
        newXS("Memcached::libmemcached::memcached_flush", XS_Memcached__libmemcached_memcached_flush, file);
        newXS("Memcached::libmemcached::memcached_quit", XS_Memcached__libmemcached_memcached_quit, file);
        newXS("Memcached::libmemcached::memcached_strerror", XS_Memcached__libmemcached_memcached_strerror, file);
        newXS("Memcached::libmemcached::memcached_lib_version", XS_Memcached__libmemcached_memcached_lib_version, file);
        newXS("Memcached::libmemcached::trace_level", XS_Memcached__libmemcached_trace_level, file);
        cv = newXS("Memcached::libmemcached::errstr", XS_Memcached__libmemcached_errstr, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Memcached::libmemcached::memcached_errstr", XS_Memcached__libmemcached_errstr, file);
        XSANY.any_i32 = 1 ;
        newXS("Memcached::libmemcached::get", XS_Memcached__libmemcached_get, file);
        newXS("Memcached::libmemcached::get_multi", XS_Memcached__libmemcached_get_multi, file);
        cv = newXS("Memcached::libmemcached::memcached_mget_into_hashref", XS_Memcached__libmemcached_mget_into_hashref, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Memcached::libmemcached::mget_into_hashref", XS_Memcached__libmemcached_mget_into_hashref, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Memcached::libmemcached::memcached_set_callback_coderefs", XS_Memcached__libmemcached_set_callback_coderefs, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Memcached::libmemcached::set_callback_coderefs", XS_Memcached__libmemcached_set_callback_coderefs, file);
        XSANY.any_i32 = 0 ;
        newXS("Memcached::libmemcached::walk_stats", XS_Memcached__libmemcached_walk_stats, file);
        newXS("Memcached::libmemcached::get_server_for_key", XS_Memcached__libmemcached_get_server_for_key, file);
    }
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

